#! /usr/bin/python

import argparse

# To Do:
# Add -V/--version argument 

def main():

    #---------#
    # PARSING #
    #---------#
    
    # Create main parser 
    
    parser = argparse.ArgumentParser(usage=None, add_help=False)    
        
    # Make flag for custom help arguments 
        
    parser.add_argument("-h", "--help", action="store_true")
    
    # Enable subparsers
    
    subparsers = parser.add_subparsers(dest="subparser_name")

    # Create search subparser & arguments 

    parser_search = subparsers.add_parser("search", usage=None, add_help=False)
    parser_search.add_argument("inFile", nargs="?")    
    parser_search.add_argument("query", nargs="?")
    parser_search.add_argument("-h", "--help", action="store_true")
    
    # Create filter subparser & arguments
    
    parser_filter = subparsers.add_parser("filter", add_help=False)
    parser_filter.add_argument("inFile", nargs="?")
    parser_filter.add_argument("-h", "--help", action="store_true")

    # Create count subparser & arguments
        
    parser_count = subparsers.add_parser("count", add_help=False)
    parser_count.add_argument("inFile", nargs="?")
    parser_count.add_argument("-h", "--help", action="store_true")

    # Create inter subparser & arguments 
        
    parser_inter = subparsers.add_parser("inter", add_help=False)
    parser_inter.add_argument("inFile", nargs="?")        
    parser_inter.add_argument("-h", "--help", action="store_true")    

    # Parse arguments 
    
    args = parser.parse_args()

    # Check if custom help flag used and display corresponding messages 

    if args.help:
        if args.subparser_name == "search":
            print(help_search)
        elif args.subparser_name == "filter":
            print(help_filter)
        elif args.subparser_name == "count":
            print(help_count)
        elif args.subparser_name == "inter":
            print(help_inter)        
        else:    
            print(help_main)

    #---------#
    # RUNNING #
    #---------#

    if args.subparser_name == "search":
        search(args)
    elif args.subparser_name == "filter":
        filter(args)
    elif args.subparser_name == "count":
        count(args)
    elif args.subparser_name == "inter":
        inter(args)        

def search(args):
    print(args.inFile)

def filter(args):
    print(args.inFile)
    
def count(args):
    print(args.inFile)

def inter(args):
    print(args.inFile)
    

#----------------------#
# CUSTOM HELP MESSAGES #
#----------------------#

help_main='''
Usage:
    charlie ....
        
Commands:
    search          Search for reads containing a sequence
    filter          Filter reads by contents or repeat size
    count           Count reads or repeat sizes
    inter           Interruption tools 
        
General Options:
    -h, --help      Show this help message and exit
    -V, --version   Show the current version (??)
'''

help_search='''
test help_search
'''

help_filter='''
test help_filter
'''

help_count='''
test help_count
'''

help_inter='''
test help_inter
'''

# Enables running as a script 

if __name__ == "__main__":
    main()
